Package com.castlabs.analytics

## Class AnalyticsSession

- java.lang.Object
- - com.castlabs.analytics.AnalyticsSession

- All Implemented Interfaces:
    `IAnalyticsSession`, `PlayerControllerPlugin.Component`
  Direct Known Subclasses:
    `AnalyticsSessionProxy`

      public abstract class AnalyticsSession
      extends Object
      implements IAnalyticsSession

  Implementation of `IAnalyticsSession` which could be enabled or disabled.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AnalyticsSession()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `adError​(CastlabsPlayerException exception)` | Inform the session that an ad error occurred.
    `void` | `adSkipped()` | Inform the session that the ad is skipped.
    `void` | `adStart​(Ad ad)` | Inform the session that an ad playback started.
    `void` | `adStop()` | Inform the session that an ad playback stopped.
    `void` | `detachFromController()` | Detach the Analytics session from the PlayerController.
    `boolean` | `getEnabled()` | Returns true if the session is enabled, otherwise false.
    `void` | `onExoPlayerStateChanged​(boolean playWhenReady, int playbackState)` | Lets the Analytics Sessions know of any state changes in ExoPlayer.
    `void` | `release()` | Terminate the AnalyticsSession.
    `void` | `reportPlayerState​(PlayerController.State state)` | Report the current player state manually.
    `void` | `seekEnd()` | Inform the session that the seeking has completed.
    `void` | `seekProcessed()` | Inform the session that the requested seek position of the video playback is processed.
    `void` | `seekStart​(long newPosition)` | Inform the session that the new position of the video playback is requested.
    `void` | `sendError​(String code, String message, int severity)` | Send an error manually.
    `void` | `setEnabled​(boolean enabled)` | Enable or disable the session.
    `void` | `start​(PlayerController playerController, AnalyticsMetaData analyticsMetaData)` | Start the session on the given controller
    `void` | `stop()` | Stop the session.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.castlabs.android.player.PlayerControllerPlugin.Component

      `id, onDestroy, onOpenBundle, onOpenState`

- - ### Constructor Detail

    - #### AnalyticsSession

          public AnalyticsSession()

  - ### Method Detail

    - #### start

          public void start​(@NonNull
                            PlayerController playerController,
                            @NonNull
                            AnalyticsMetaData analyticsMetaData)

      Description copied from interface: `IAnalyticsSession`
      Start the session on the given controller
      Specified by:
        `start` in interface `IAnalyticsSession`
      Parameters:
        `playerController` - The player controller
        `analyticsMetaData` - The meta-data associated with this session

    - #### stop

          public void stop()

      Description copied from interface: `IAnalyticsSession`
      Stop the session.
      Specified by:
        `stop` in interface `IAnalyticsSession`

    - #### adStart

          public void adStart​(Ad ad)

      Description copied from interface: `IAnalyticsSession`
      Inform the session that an ad playback started.
      Specified by:
        `adStart` in interface `IAnalyticsSession`
      Parameters:
        `ad` - The ad metadata. Contains streamType (Either `SdkConsts.AD_EMBEDDED` if the ad is embedded into the content or `SdkConsts.AD_SEPARATE` if the ad is played separate from the main content.), playerType (Either `SdkConsts.AD_EMBEDDED` if the ad is using the same player as the main content or `SdkConsts.AD_SEPARATE` if the ad is played in a separate player and adPosition The ad position. One of `SdkConsts.AD_POSITION_PREROLL` `SdkConsts.AD_POSITION_MIDROLL` , or `SdkConsts.AD_POSITION_POSTROLL`

    - #### adStop

          public void adStop()

      Description copied from interface: `IAnalyticsSession`
      Inform the session that an ad playback stopped.
      Specified by:
        `adStop` in interface `IAnalyticsSession`

    - #### adError

          public void adError​(CastlabsPlayerException exception)

      Description copied from interface: `IAnalyticsSession`
      Inform the session that an ad error occurred.
      Specified by:
        `adError` in interface `IAnalyticsSession`
      Parameters:
        `exception` - The error's exception

    - #### adSkipped

          public void adSkipped()

      Description copied from interface: `IAnalyticsSession`
      Inform the session that the ad is skipped.
      Specified by:
        `adSkipped` in interface `IAnalyticsSession`

    - #### reportPlayerState

          public void reportPlayerState​(PlayerController.State state)

      Description copied from interface: `IAnalyticsSession`
      Report the current player state manually. This is used for the cases that `PlayerListener.onStateChanged(PlayerController.State)` is called before but we want to report it now, same as switching between playlist items in `MultiControllerPlaylist`
      Specified by:
        `reportPlayerState` in interface `IAnalyticsSession`

    - #### sendError

          public void sendError​(String code,
                                String message,
                                int severity)

      Description copied from interface: `IAnalyticsSession`
      Send an error manually. Note that the player integration takes care of playback error occurring during playback. Use this method to send error that happen outside of the playback session.
      Specified by:
        `sendError` in interface `IAnalyticsSession`
      Parameters:
        `code` - The error code
        `message` - The error message
        `severity` - The severity of the error

    - #### seekStart

          public void seekStart​(long newPosition)

      Description copied from interface: `IAnalyticsSession`
      Inform the session that the new position of the video playback is requested.
      Specified by:
        `seekStart` in interface `IAnalyticsSession`
      Parameters:
        `newPosition` - the new position in microseconds

    - #### seekEnd

          public void seekEnd()

      Description copied from interface: `IAnalyticsSession`
      Inform the session that the seeking has completed.

      Triggered when the player is ready to continue playback by transitioning to either `PlayerController.State.Playing` or `PlayerController.State.Pausing`.

      Specified by:
        `seekEnd` in interface `IAnalyticsSession`

    - #### seekProcessed

          public void seekProcessed()

      Description copied from interface: `IAnalyticsSession`
      Inform the session that the requested seek position of the video playback is processed. This is called right after the player has updated the internal playback position.
      Specified by:
        `seekProcessed` in interface `IAnalyticsSession`

    - #### detachFromController

          public void detachFromController()

      Description copied from interface: `IAnalyticsSession`
      Detach the Analytics session from the PlayerController. Unregister listeners and remove any references.

      This method allows to unbind the AnalyticsSession from a PlayerController, to later set it to a new controller and continue with the same analytics session.

      Should be called by client code after getting the AnalyticsSession via `PlayerController.getAnalyticsSession()` , and before releasing the PlayerController.

      You can later re-attach the AnalyticsSession to a PlayerController before `opening` it with the `PlayerController.setAnalyticsSession(AnalyticsSession)` method

      Specified by:
        `detachFromController` in interface `IAnalyticsSession`

    - #### onExoPlayerStateChanged

          public void onExoPlayerStateChanged​(boolean playWhenReady,
                                              int playbackState)

      Description copied from interface: `IAnalyticsSession`
      Lets the Analytics Sessions know of any state changes in ExoPlayer.

      This method allows any interested Analytics sessions to know of any changes in the ExoPlayer even if it doesn't correspond to any state changes in the PlayerController.

      Specified by:
        `onExoPlayerStateChanged` in interface `IAnalyticsSession`

    - #### release

          public void release()

      Description copied from interface: `IAnalyticsSession`
      Terminate the AnalyticsSession. Although implementation is vendor-specific, this method will terminate any ongoing session as if the player itself had been destroyed. Generally, there's no need to call this manually. Unless you're detaching the session and not reusing it later.
      Specified by:
        `release` in interface `IAnalyticsSession`

    - #### getEnabled

          public boolean getEnabled()

      Returns true if the session is enabled, otherwise false.
      Returns:
        enabled

    - #### setEnabled

          public void setEnabled​(boolean enabled)

      Enable or disable the session.
      Parameters:
        `enabled` - the value